import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.io.IOException;


public class FeatureTest extends DefaultHandler {

  private XMLReader parser; 

  public void endElement(String namespaceURI, String localName,
     String qualifiedName) {

    try {
      parser.setFeature("http://xml.org/sax/features/validation", true);
      System.out.println("Failed Silently");
    }
    catch (SAXNotSupportedException e) {
      // This is what should be thrown
      System.out.println("SAXNotSupportedException: " + e);
    }
    catch (SAXNotRecognizedException e) {
      System.out.println("SAXNotRecognizedException: " + e);
    } 
    catch (SAXException e) {
      // This is what is thrown
      System.out.println("SAXException: " + e);
    }
    catch (Exception e) {
      // Huh???
      System.out.println("Unexpected Exception: " + e.getClass() + " " + e.getMessage());
    }

  }

  public static void main(String[] args) {
    
    FeatureTest handler = new FeatureTest();
    try {
      handler.parser = XMLReaderFactory.createXMLReader(
       "org.apache.xerces.parsers.SAXParser");
    }
    catch (SAXException ee) {
      System.err.println("Couldn't locate a SAX parser");
      return;          
    }
     
    if (args.length == 0) {
      System.out.println(
       "Usage: java EventReporter URL1 URL2..."); 
    } 
      
    // Install the Document Handler      
    handler.parser.setContentHandler(handler);
    
    // start parsing... 
    for (int i = 0; i < args.length; i++) {
      
      // command line should offer URIs or file names
      try {
        handler.parser.parse(args[i]);
      }
      catch (SAXParseException e) { // well-formedness error
        System.out.println(args[i] + " is not well formed.");
        System.out.println(e.getMessage()
         + " at line " + e.getLineNumber() 
         + ", column " + e.getColumnNumber());
      }
      catch (SAXException e) { // some other kind of error
        System.out.println("SAXException" + e.getMessage());
      }
      catch (IOException e) {
        System.out.println("Could not report on " + args[i] 
         + " because of the IOException " + e);
      }
      
    }  
  
  }

}